public typealias MoveCallback = ([Move.Action], Board) async -> Move.Action

public class HumanPlayer : Player {
    private let callback: MoveCallback
    
    public override var type: PlayerType { .Human }

    public init(name: String, piece_type: PieceType, callback: @escaping MoveCallback) {
        self.callback = callback

        super.init(name: name, piece_type: piece_type)
    }

    public override func chooseMove(allowed_moves moves: [Move.Action], board: Board) async -> Move.Action {
        await callback(moves, board)
    }
}
