import Foundation
import Model

public enum DeError: Error {
    case CodableContext
    case InvalidVariant
    case InvalidData
    case InitializationFailed
}

extension CodingUserInfoKey {
    public static let gameDecodingContext = CodingUserInfoKey(rawValue: "gameDecodingContext")!
}

public class CodableContext {
    internal var callbackFactory: ((_ name: String, _ type: PieceType) -> MoveCallback)?
    internal var players: [Player]? = nil
    internal var board: Board? = nil
    
    public init(creatingCallbacks callbackFactory: ((_ name: String, _ type: PieceType) -> MoveCallback)? = nil) {
        self.callbackFactory = callbackFactory
    }
}

enum EnumCommonCodingKeys: CodingKey {
    case type
}
